



<!DOCTYPE html><html lang=zh-CN><head><meta http-equiv="Content-Type" content="text/html; charset=utf-8" /><meta http-equiv="X-UA-Compatible" content="IE=edge,chrome=1"><meta name="applicable-device" content="pc,mobile"><meta name="renderer" content="webkit"><meta name="viewport" content="width=device-width,initial-scale=1.0,maximum-scale=5,viewport-fit=cover">
<title>Android中的广播</title>	
<script src="//n4.ikafan.com/assets/run_prettify.js?ac"></script>
<link rel="stylesheet" href="//n4.ikafan.com/assetsg/style.css">
<!-- <link rel="stylesheet" href="//pic.ikafan.com/staticx/shuzhiduo/1/css.grace/fontello.css?ac"> -->
<!-- <link rel="stylesheet" href="//pic.ikafan.com/staticx/shuzhiduo/1/css.grace/animation.css?ac"> -->
<script>
var _hmt = _hmt || [];
(function() {
  var hm = document.createElement("script");
  hm.src = "https://hm.baidu.com/hm.js?c61d51e9fdcf1d1631ddfce8df9cd119";
  var s = document.getElementsByTagName("script")[0]; 
  s.parentNode.insertBefore(hm, s);
})();
</script>
<script src="https://n4.ikafan.com/g/show.js"></script>

</head>
<div id="header" class="navbar navbar-default navbar-fixed-top header-01">
	<div class="container">
		<h1 class="logo">
			<a  href="/" title="巴特西"/>
							巴特西
			</a>
		</h1>
				<div role="navigation"  class="site-nav  primary-menu">
			<div class="menu-fix-box">
				 <ul id="menu-navigation" class="menu" >
<li><a href="/">首页</a></li>
<!-- <li><a href="/search/Hadoop/">Hadoop</a></li>
<li><a href="/search/Linux/">Linux</a></li>
<li><a href="/search/jQuery/">jQuery</a></li> -->
<li><a href="/search/Python/">Python</a></li>
<li><a href="/search/Java/">Java</a></li>
<li><a href="/search/PHP/">PHP</a></li>
<li><a href="/search/IOS/">IOS</a></li>
<li><a href="/search/Andorid/">Andorid</a></li>
<li><a href="/search/NodeJS/">NodeJS</a></li>
<li><a href="/search/JavaScript/">JavaScript</a></li>
<li><a href="/search/HTML5/">HTML5</a></li>
				</ul>					 			
			</div>
		</div>
				<!--<div class="right-nav">
				<button class="js-toggle-search"><i class="icon-search"></i></button>
		</div>-->
       
			</div>	
</div>

<div id="page-content">
	<div class="container">
		<div class="row">
			
			<div class="blog-post">
								<!--<div class="posts-top-cjtz clearfix"></div>-->
								<div class="post">
										<div class="post-title">
											<div id="title_top"></div>
<script>insertAdIfNeeded();</script>
						<h1 class="title">Android中的广播</h1>
						<div class="post_icon">
							<span class="icon-clock-1"> 2024-02-03 01:04:33 </span>
						</div>
										<div class="post-content">
													<div id="single_top"></div>
<script>insertAdIfNeeded();</script>
											
		<h1>Android中的广播</h1>
<p>广播接受器，可以比喻成收音机。而广播则可以看成电台。</p>
<p>Android系统内部相当于已经有一个电台 定义了好多的广播事件，比如外拨电话 短信到来 sd卡状态 电池电量变化...</p>
<h2>广播的两种注册方式</h2>
<h3>静态注册</h3>
<p>静态注册写在<code>AndroidManifest.xml</code>，即使没有进入应用（没有写在onCreate里面），也可以接收到。如接收开机广播。</p>
<h4>监听外拨电话</h4>
<p>写个拨打电话，自动加区号的功能。区号可以自定义，每次填了区号后，会存到偏好文件中。若不改区号，每次默认打电话都会加这个区号。（这个程序实在没什么意义）</p>
<p>可直接在Android Studio中File -&gt; New -&gt; Other -&gt; Broadcast Receiver。需要重写OnReceive方法，这个方法在广播接受器接收到广播的时候被调用。</p>
<p><code>AndroidManifest.xml</code>下注册</p>
<div>
<pre class="prettyprint linenums"><code>&lt;receiver
      android:name=".TelReceiver"
    android:enabled="true"
    android:exported="true"&gt;
      &lt;intent-filter &gt;
        &lt;action android:name="android.intent.action.NEW_OUTGOING_CALL"/&gt;
      &lt;/intent-filter&gt;
&lt;/receiver&gt;</code></pre>
</div>
<p>其中<code>android:enabled="true"</code>表示启用这个广播，<strong>默认为true</strong>。<code>android:enabled="true"</code>表示这个广播接收器可以接收本程序以外的广播。<strong>其默认值是由receiver中有无intent-filter决定的，如果有intent-filter，默认值为true，否则为false。</strong>一般就上面默认生成的写法就好了，显式指定为true更直观不是吗。</p>
<p>同时申请权限<code>&lt;uses-permission android:name="android.permission.PROCESS_OUTGOING_CALLS"/&gt;</code>，记住<strong>一定要申请运行时权限啊</strong>，我傻傻的调试了半天......</p>
<p>主界面一个输入框用来自定义默认区号，和一个按钮保存到偏好文件。</p>
<div>
<pre class="prettyprint linenums"><code>&lt;?xml version="1.0" encoding="utf-8"?&gt;
&lt;LinearLayout xmlns:android="http://schemas.android.com/apk/res/android"
    xmlns:tools="http://schemas.android.com/tools"
    android:orientation="vertical"
    android:layout_width="match_parent"
    android:layout_height="match_parent"
    tools:context="com.example.telbroadcastreceivertest.MainActivity"&gt;

    &lt;EditText
        android:id="@+id/et_area_code"
        android:layout_width="match_parent"
        android:layout_height="wrap_content" /&gt;

    &lt;Button
        android:id="@+id/bt_save"
        android:layout_width="match_parent"
        android:layout_height="wrap_content"
        android:text="保存区号"/&gt;

&lt;/LinearLayout&gt;
 </code></pre>
</div>
<p>MainActivity</p>
<div>
<pre class="prettyprint linenums"><code>package com.example.telbroadcastreceivertest;

import android.Manifest;
import android.content.Context;
import android.content.SharedPreferences;
import android.content.pm.PackageManager;
import android.support.v4.app.ActivityCompat;
import android.support.v4.content.ContextCompat;
import android.support.v7.app.AppCompatActivity;
import android.os.Bundle;
import android.view.View;
import android.widget.Button;
import android.widget.EditText;
import android.widget.Toast;

public class MainActivity extends AppCompatActivity {

    private EditText editText;
    private Context mContext;
    @Override
    protected void onCreate(Bundle savedInstanceState) {
        super.onCreate(savedInstanceState);
        setContentView(R.layout.activity_main);
        mContext = this;
        if (ContextCompat.checkSelfPermission(MainActivity.this, Manifest.permission.PROCESS_OUTGOING_CALLS) != PackageManager.PERMISSION_GRANTED) {
            ActivityCompat.requestPermissions(MainActivity.this, new String[]{Manifest.permission.PROCESS_OUTGOING_CALLS}, 1);
        }

        editText = (EditText) findViewById(R.id.et_area_code);
        Button button = (Button) findViewById(R.id.bt_save);

        button.setOnClickListener(new View.OnClickListener() {
            @Override
            public void onClick(View v) {
                String areaCode = editText.getText().toString().trim();
                SharedPreferences spf = getSharedPreferences("code", MODE_PRIVATE);
                // 保存区号到偏好文件，下次拨打电话默认加这个前缀
                spf.edit().putString("code", areaCode).apply();
                Toast.makeText(mContext, "区号保存成功", Toast.LENGTH_SHORT).show();
            }
        });
    }
}
 </code></pre>
</div>
<p>广播接收器，可以拦截外拨电话的<strong>有序广播</strong></p>
<div>
<pre class="prettyprint linenums"><code>package com.example.telbroadcastreceivertest;

import android.content.BroadcastReceiver;
import android.content.Context;
import android.content.Intent;
import android.content.SharedPreferences;

public class TelReceiver extends BroadcastReceiver {

    @Override
    public void onReceive(Context context, Intent intent) {
        SharedPreferences spf = context.getSharedPreferences("code", Context.MODE_PRIVATE);
        String areaCode = spf.getString("code", "");

        // 接收前一个广播接收者的所设定的数据,这里是拨号器的广播接收者，数据是电话号码
        String phoneNumber = getResultData();
        // 区号一般以0开头，若号码不以0开头，就加上区号
        if (!phoneNumber.startsWith("0")) {
            setResultData(areaCode + phoneNumber);
        }
    }
}
 </code></pre>
</div>
<p><strong>向外拨打电话时系统会发出一个有序广播,<code>android.intent.action.NEW_OUTGOING_CALL</code>，虽然该广播最终会被拔号器里的广播接收者所接收并实现电话拔打，但我们可以在广播传递给拔号广播接收者之前先得到该广播，并添加了区号后再拨打出去。</strong></p>
<p>填写默认的区号。</p>
<p><img referrerpolicy="no-referrer"src="http://obvjfxxhr.bkt.clouddn.com/outgoing_Screenshot_2017-05-09-17-32-20-962_com.example.te.png"></p>
<p>由于使用真机，拨号使用了一个空号。</p>
<p><img referrerpolicy="no-referrer"src="http://obvjfxxhr.bkt.clouddn.com/outgoing_Screenshot_2017-05-09-17-11-51-910_com.android.co.png"></p>
<p>看图，确实是添加了区号再拨打出去的</p>
<p><img referrerpolicy="no-referrer"src="http://obvjfxxhr.bkt.clouddn.com/outgoing_Screenshot_2017-05-09-17-11-56-551_com.android.in.png"></p>
<p>测试成功后，赶紧给卸载了，这会影响电话拨打功能的。</p>
<h3>动态注册</h3>
<h4>监听SD卡的挂载/未挂载</h4>
<p>注意：这里所说的SD卡是真实的<strong>外置SD卡</strong>。</p>
<p><strong>之前使用真机，还有模拟器，SD卡的选择是internal storage而非protable storage。这样就不带外置SD卡，所以一直接收不到广播，折腾了半天。引以为戒！</strong></p>
<p>AndroidManifest.xml里面</p>
<div>
<pre class="prettyprint linenums"><code>&lt;receiver android:name=".SDReceiver"
     android:enabled="true"
     android:exported="true"&gt;
  &lt;intent-filter&gt;
    &lt;action android:name="android.intent.action.MEDIA_MOUNTED"/&gt;
    &lt;action android:name="android.intent.action.MEDIA_REMOVED"/&gt;
    &lt;action android:name="android.intent.action.MEDIA_UNMOUNTED"/&gt;
    &lt;!-- 一定要指定下面这个scheme为"file"，否则无法接收到广播 --&gt;
    &lt;data android:scheme="file"/&gt;
  &lt;/intent-filter&gt;
&lt;/receiver&gt;</code></pre>
</div>
<p>上面的写法是静态注册，用动态注册的方式如下，<strong>也一定要加上scheme</strong>。注意动态注册只能当前Activity能接收到广播，因为是写在onCreate方法里的嘛。</p>
<div>
<pre class="prettyprint linenums"><code>// onCreate方法内
IntentFilter intentFilter = new IntentFilter();
// 同时加了三个action，可以接收到这三种系统广播
intentFilter.addAction(Intent.ACTION_MEDIA_MOUNTED);
intentFilter.addAction(Intent.ACTION_MEDIA_UNMOUNTED);
intentFilter.addAction(Intent.ACTION_MEDIA_EJECT);
// scheme必须加
intentFilter.addDataScheme("file");
// 实例化广播接收者
SDReceiver sdReceiver = new SDReceiver();
// 注册广播接收器，接收一个实例和intentFilter。匹配action和data
registerReceiver(sdReceiver , intentFilter);

// !!! 注册了还必须注销，在onDestroy方法内
@Override
    protected void onDestroy() {
          unregisterReceiver(telReceiver);
        super.onDestroy();
    }</code></pre>
</div>
<p><strong>动态注册，必须注销。而静态注册，无需操心注销的事。</strong></p>
<p><strong>动态注册的优先级是要高于静态注册优先级的</strong></p>
<p>然后新建一个Broadcast Receiver重写receive方法，判断状态</p>
<div>
<pre class="prettyprint linenums"><code>@Override
public void onReceive(Context context, Intent intent) {
    String action = intent.getAction();
    if ("android.intent.action.MEDIA_MOUNTED".equals(action)) {
      Log.d("SD卡", "外置SD卡存在，且已挂载mounted");
    } else if ("android.intent.action.MEDIA_UNMOUNTED".equals(action)) {
      Log.d("SD卡", "外置SD卡存在，但未挂载unmounted");
    } else if (Intent.ACTION_MEDIA_EJECT.equals(action)) {
      Log.d("SD卡", "外置SD卡卸载ejected");
    } else if (Intent.ACTION_MEDIA_REMOVED.equals(action)) {
      Log.d("SD卡", "外置SD卡移除removed");
    }</code></pre>
</div>
<p>当挂载了外置SD卡时候，就会打印<code>外置SD卡存在，且已挂载mounted</code>，正常卸载时候打印<code>外置SD卡存在，但未挂载</code>和<code>外置SD卡卸载ejected</code>。当拔出了SD卡的情况，不仅打印上面两个，还会打印<code>外置SD卡移除removed</code>。</p>
<h4>拓展</h4>
<p>现在的手机一般很少插入了真实的<strong>外置SD卡</strong>，我们之前所说的SD卡指的是虚拟的<strong>内置SD卡</strong>，又叫做<strong>internal storage</strong>，路径是<code>/mnt/sdcard</code>或者<code>/storage/emulated/0</code>又或者<code>/sdcard</code>，这三个路径指向同一个地方。</p>
<div>
<pre class="prettyprint linenums"><code>Environment.getExternalStorageDirectory().getPath(); // 这里小米真机打印/storage/emulated/0</code></pre>
</div>
<p>。<strong>从Androidkk4.4开始，第三方应用程序是无法访问(读/写)外置SD卡的；仅仅只有系统级别的并且使用系统签名的APP可以访问外置SD卡。但就我测试环境（API25）来看，是并不影响监听外置SD卡状态的。</strong></p>
<p>还可以判断<strong>内置SD卡</strong>的状态，使用如下方法。当然外置SD的拔插，都不影响内置SD卡。都会打印<strong>mounted</strong></p>
<div>
<pre class="prettyprint linenums"><code>Log.d("SDcard", Environment.getExternalStorageState()); // 打印mounted
Log.d("SDcard", Environment.getExternalStorageDirectory().getPath()); // 打印 /storage/emulated/0</code></pre>
</div>
<h2>接收（拦截）短信</h2>
<p>注册</p>
<div>
<pre class="prettyprint linenums"><code>&lt;!-- 申请接收短信的权限 --&gt;
&lt;uses-permission android:name="android.permission.RECEIVE_SMS" /&gt;
&lt;!-- 省略部分代码 --&gt;
&lt;receiver
    android:name=".SmsReceiver"
    android:enabled="true"
    android:exported="true"&gt;
  &lt;intent-filter&gt;
    &lt;action android:name="android.provider.Telephony.SMS_RECEIVED" /&gt;
  &lt;/intent-filter&gt;
&lt;/receiver&gt;</code></pre>
</div>
<p>申请的权限记得要动态申请。</p>
<div>
<pre class="prettyprint linenums"><code>if (ContextCompat.checkSelfPermission(MainActivity.this, Manifest.permission.RECEIVE_SMS) != PackageManager.PERMISSION_GRANTED) {
      ActivityCompat.requestPermissions(MainActivity.this, new String[]{Manifest.permission.RECEIVE_SMS}, 1);
}</code></pre>
</div>
<p>广播接收器</p>
<div>
<pre class="prettyprint linenums"><code>package com.example.telbroadcastreceivertest;

import android.content.BroadcastReceiver;
import android.content.Context;
import android.content.Intent;
import android.telephony.SmsMessage;
import android.util.Log;

public class SmsReceiver extends BroadcastReceiver {
    @Override
    public void onReceive(Context context, Intent intent) {
        // 每一个object为一条短信,实际返回的是byte[][],一个pdu对应byte[]
        Object[] smss = (Object[]) intent.getExtras().get("pdus");
        Log.d("sms", String.valueOf(smss.length));
        for (Object sms : smss) {
            // API23后，必须加入format参数
            String format = intent.getStringExtra("format"); // 模拟器，打印3gpp
            Log.d("sms", format);
            if (android.os.Build.VERSION.SDK_INT &gt;= android.os.Build.VERSION_CODES.M) {
                SmsMessage smsMessage = SmsMessage.createFromPdu((byte[]) sms, format);
                // 获取发送短信的内容
                // 功能更强大，如果有，可以得到email message body和address
                String dispalyBody = smsMessage.getDisplayMessageBody();
                String displayAddr = smsMessage.getDisplayOriginatingAddress();

                // 纯文本的消息体
                String body = smsMessage.getMessageBody();
                // 获取发送者号码
                String address = smsMessage.getOriginatingAddress();
                Log.d("sms", "disBody:"+dispalyBody); // 由于发送的就是一般的文本短信，打印内容和下面一样
                Log.d("sms", "body:"+body);
                Log.d("sms", "disAddr:"+displayAddr); // 打印内容和下面一样
                Log.d("sms", "addr:"+address);
            }

        }
    }
}
 </code></pre>
</div>
<p><strong>API23开始，<code>SmsMessage.createFromPdu(byte[] sms);</code>被弃用。使用<code>SmsMessage.createFromPdu((byte[]) sms, format);</code>format可以用<code>String format = intent.getStringExtra("format");</code>获取。</strong></p>
<p>这个例子在真机上（可恶的小米5S）测试又失败了。估计有啥流氓软件给先拦截了。不过，在模拟器上测试成功。</p>
<h2>监听应用的安装、更新、卸载</h2>
<p>注册</p>
<div>
<pre class="prettyprint linenums"><code>&lt;receiver android:name=".APPReceiver"&gt;
  &lt;intent-filter&gt;
    &lt;!-- 安装应用 --&gt;
    &lt;action android:name="android.intent.action.PACKAGE_ADDED" /&gt;
    &lt;!-- 更新已有应用 --&gt;
    &lt;action android:name="android.intent.action.PACKAGE_REPLACED" /&gt;
    &lt;!-- 卸载应用 --&gt;
    &lt;action android:name="android.intent.action.PACKAGE_REMOVED" /&gt;
    &lt;!-- 携带包名，这个必须要加上 --&gt;
    &lt;data android:scheme="package" /&gt;
  &lt;/intent-filter&gt;
&lt;/receiver&gt;</code></pre>
</div>
<p>不需要申请啥权限</p>
<p>广播接收器</p>
<div>
<pre class="prettyprint linenums"><code>package com.example.telbroadcastreceivertest;

import android.content.BroadcastReceiver;
import android.content.Context;
import android.content.Intent;
import android.net.Uri;
import android.util.Log;

public class APPReceiver extends BroadcastReceiver {
    @Override
    public void onReceive(Context context, Intent intent) {
        // 判断广播类型
        String action = intent.getAction();
        //获取包名
        // intent.getData().toString
        String appName = intent.getDataString();

        if (Intent.ACTION_PACKAGE_ADDED.equals(action)) {
            Log.i("APPReceiver", "ADD" + appName);
        } else if (Intent.ACTION_PACKAGE_REPLACED.equals(action)) {
            Log.i("APPReceiver", "REPLACED" + appName);
        } else if (Intent.ACTION_PACKAGE_REMOVED.equals(action)) {
            Log.i("APPReceiver", "REMOVE" + appName);
        }
    }
}</code></pre>
</div>
<p>应用在更新时，会先REMOVED，然后在REPLACED。在本例中，自己本身被安装和卸载，接收不到ADDED和REMOVED广播。</p>
<h2>应用未启动过，接收不到广播</h2>
<blockquote><p>资料来自<a href="https://zhuanlan.zhihu.com/zmywly8866" rel="external nofollow noreferrer">张明云的知识共享</a></p>
<p>从Android3.1开始，新安装的程序会被置于”stopped”状态，并且只有在至少手动启动这个程序一次后该程序才会改变状态，能够正常接收到指定的广播消息。Android这样做的目的是防止广播无意或者不必要地开启未启动的APP后台服务。也就是说在Android3.1及以上的版本，在未启动的情况下通过应用自身完成一些操作是不可能的，但Android提供了一种借助其它应用发送指定Flag广播的方式，达到应用在未启动的情况下仍然能够收到消息的效果。</p>
<p>从Android 3.1开始，系统给Intent定义了两个新的Flag，分别为FLAG_INCLUDE_STOPPED_PACKAGES（表示包含未启动的App）和FLAG_EXCLUDE_STOPPED_PACKAGES（表示不包含未启动的App），用来控制Intent是否要对处于停止状态的App起作用，具体的操作方式如下</p>
<div>
<pre class="prettyprint linenums"><code>Intent intent = new Intent();
intent.setAction("com.xxx.xxx.ACTION_XXXX");
// 这句是关键
intent.addFlags(Intent.FLAG_INCLUDE_STOPPED_PACKAGES);
sendBroadcast(intent);</code></pre>
</div></blockquote>
<h2>监听开机广播</h2>
<p>注册</p>
<div>
<pre class="prettyprint linenums"><code>&lt;receiver
    android:name=".BootCompleteReceiver"
    android:enabled="true"
    android:exported="true"&gt;
  &lt;intent-filter&gt;
    &lt;action android:name="android.intent.action.BOOT_COMPLETED" /&gt;
  &lt;/intent-filter&gt;
&lt;/receiver&gt;</code></pre>
</div>
<p>申请权限</p>
<p><code>&lt;uses-permission android:name="android.permission.RECEIVE_BOOT_COMPLETED" /&gt;</code></p>
<p>广播接收器</p>
<div>
<pre class="prettyprint linenums"><code>@Override
public void onReceive(Context context, Intent intent) {
    Toast.makeText(context, "Boot Complete", Toast.LENGTH_SHORT).show();
}</code></pre>
</div>
<h2>一些特殊的广播</h2>
<p><strong>比如操作特别频繁的广播事件，屏幕的关闭和打开 ，电量的变化等广播接收器静态注册无效</strong></p>
<div>
<pre class="prettyprint linenums"><code>android.intent.action.SCREEN_ON
android.intent.action.SCREEN_OFF
android.intent.action.BATTERY_CHANGED
android.intent.action.CONFIGURATION_CHANGED
android.intent.action.TIME_TICK</code></pre>
</div>
<p>因为这些事android的基本事件，如果大多数程序都监听，会大大的拖慢整个系统（占用内存等），所以android不鼓励我们在程序退出的情况下监听这些事件。不过还是可以通过在service里面注册广播接受器...来解决。</p>
<div>
<pre class="prettyprint linenums"><code>IntentFilter intentFilter = new IntentFilter();
intentFilter.addAction(Intent.ACTION_SCREEN_OFF);
intentFilter.addAction(Intent.ACTION_SCREEN_ON);
screenReceiver = new ScreenReceiver();
registerReceiver(screenReceiver, intentFilter);</code></pre>
</div>
<p>别忘了注销</p>
<div>
<pre class="prettyprint linenums"><code>@Override
protected void onDestroy() {
      unregisterReceiver(screenReceiver);
      super.onDestroy();
}</code></pre>
</div>
<h2>监听网络状态变化</h2>
<p><strong>可以静态注册，但是已经被弃用。最好动态注册。</strong></p>
<div>
<pre class="prettyprint linenums"><code>IntentFilter intentFilter = new IntentFilter();
intentFilter.addAction("android.net.conn.CONNECTIVITY_CHANGE");
networkReceiver = new NetworkReceiver();
registerReceiver(networkReceiver, intentFilter);</code></pre>
</div>
<p>取消注册</p>
<div>
<pre class="prettyprint linenums"><code>@Override
protected void onDestroy() {
      unregisterReceiver(screenReceiver);
      super.onDestroy();
}</code></pre>
</div>
<div>
<pre class="prettyprint linenums"><code>@Override
public void onReceive(Context context, Intent intent) {
    ConnectivityManager connectivityManager = (ConnectivityManager) context.getSystemService(Context.CONNECTIVITY_SERVICE);
    // 获得正在使用的网络，若无网络连接返回null，所以需要判断
    NetworkInfo networkInfo = connectivityManager.getActiveNetworkInfo();

    if (networkInfo != null &amp;&amp; networkInfo.isAvailable()) {
      String typeName = networkInfo.getTypeName(); // 返回MOBILE或WIFI
      Toast.makeText(context, typeName + " network is available", Toast.LENGTH_LONG).show();
    } else {
      Toast.makeText(context, "network is unavailable", Toast.LENGTH_SHORT).show();
    }
}</code></pre>
</div>
<p>记得申请权限 <code>&lt;uses-permission android:name="android.permission.ACCESS_NETWORK_STATE" /&gt;</code></p>
<h2>自定义广播</h2>
<h3>标准广播和有序广播</h3>
<ul><li>标准广播：异步执行，广播发出后，所有广播接收器几乎同时接收到这条广播。无顺序可言，效率高但是无法被截获，也无法修改数据。<strong>可想象成开会时，听领导讲话</strong>。</li>
<li>有序广播：同步执行，广播发出后，同一时刻只有一个广播接收器能收到。当这个广播接收器处理完成之后，可修改数据后传给下一个接收器，也可以选择截获（不继续往下传递），显然这是有顺序的。<strong>可想象成一个人给另外一个人传话，我可以不告诉你呀</strong>。</li></ul>
<h3>发送标准广播</h3>
<p>定义了两个广播接受器，接收同一个自定义广播<code>com.example.broadcasttest.MY_BROADCAST</code></p>
<div>
<pre class="prettyprint linenums"><code>&lt;receiver
    android:name=".MyBroadcastReceiver"
    android:enabled="true"
    android:exported="true"&gt;
  &lt;intent-filter&gt;
    &lt;action android:name="com.example.broadcasttest.MY_BROADCAST" /&gt;
  &lt;/intent-filter&gt;
&lt;/receiver&gt;

&lt;receiver
    android:name=".AnotherReceiver"
    android:enabled="true"
    android:exported="true" &gt;
  &lt;intent-filter&gt;
    &lt;action android:name="com.example.broadcasttest.MY_BROADCAST" /&gt;
  &lt;/intent-filter&gt;
&lt;/receiver&gt;</code></pre>
</div>
<p>然后在某个活动中，匹配了action在发送广播就行了。</p>
<div>
<pre class="prettyprint linenums"><code>Intent intent = new Intent("com.example.broadcasttest.MY_BROADCAST");
sendBroadcast(intent);</code></pre>
</div>
<p>两个广播接收器</p>
<div>
<pre class="prettyprint linenums"><code>public class MyBroadcastReceiver extends BroadcastReceiver {

    @Override
    public void onReceive(Context context, Intent intent) {
        Toast.makeText(context, "Received in MyBroadcastReceiver", Toast.LENGTH_SHORT).show();
    }
}

// 另外一个文件
public class AnotherReceiver extends BroadcastReceiver {

    @Override
    public void onReceive(Context context, Intent intent) {
        Toast.makeText(context, "Received in AnotherBroadcastReceiver", Toast.LENGTH_SHORT).show();
    }
}</code></pre>
</div>
<p>上面的两个接收器都会接收到这个广播。<strong>在无序广播中，abortBroadcast()是无效的，而且会在logcat发出警告。</strong></p>
<h3>发送有序广播</h3>
<p>还是上面的两个接收器，不同的是给AnotherReceiver设置了优先级。priority可在[-1000,1000]之间设置，默认为0，值越大优先级越高。</p>
<div>
<pre class="prettyprint linenums"><code>&lt;receiver
    android:name=".AnotherReceiver"
    android:enabled="true"
    android:exported="true" &gt;
  &lt;intent-filter android:priority="1000"&gt;
    &lt;action android:name="com.example.broadcasttest.MY_BROADCAST" /&gt;
  &lt;/intent-filter&gt;
&lt;/receiver&gt;</code></pre>
</div>
<p>且在AnotherReceiver中阻断了传播</p>
<div>
<pre class="prettyprint linenums"><code>public class AnotherReceiver extends BroadcastReceiver {

    @Override
    public void onReceive(Context context, Intent intent) {
        Toast.makeText(context, "Received in AnotherBroadcastReceiver", Toast.LENGTH_SHORT).show();
        // 截获后阻断传播
        abortBroadcast();
    }
}</code></pre>
</div>
<p>这样只有AnotherReceiver能接收打广播了，由于在此阻断了传播，所以 MyBroadcastReceiver接收不到。</p>
<p>不过如果这样发送MyBroadcastReceiver就又可以接收到了</p>
<div>
<pre class="prettyprint linenums"><code>sendOrderedBroadcast(intent, null, new MyBroadcastReceiver(), null, RESULT_OK, null, null);
 </code></pre>
</div>
<p>注意第三个参数，是最终接收器，不管有没有被截获，最后都会传到这个接收器。所以，上面的截获对于MyBroadcastReceiver是无意义的，因为在发送有序广播时指定了这个接收器为最终接收器。而且<strong>最终的Receiver无需注册</strong>。把上面的MyBroadcastReceiver注册代码删掉，也能接收到。</p>
<h2>本地广播</h2>
<p>前面发送和接收的都是全局广播，发出的广播可以被任何应用程序接收到；而且也可以接收来自其他任何应用程序的广播。这样容易引起安全问题。如发送一些敏感数据，如果被其他软件截获，又或者其他程序不停向我们发送广播。</p>
<p>使用本地广播，使得广播只能在应用程序内部传递。广播接收器也只能接收来自本应用程序的广播。这样安全性就得到保障。</p>
<p><strong>本地广播无法通过静态注册来接收。因为静态就是让程序在未启动的情况下也能收到广播。但是在发送本地广播的时候，我们的程序肯定是在运行的。因此完全不需要使用静态注册.</strong></p>
<p>需要使用到LocalBroadcastManager</p>
<div>
<pre class="prettyprint linenums"><code>mContext = this;
// 先注册
IntentFilter intentFilter = new IntentFilter();
intentFilter.addAction("com.example.action.LOCAL_BROADCAST");
localReceiver = new LocalReceiver();
// 获得实例
localBroadcastManager = LocalBroadcastManager.getInstance(mContext);
// 使用localBroadcastManager的注册方法
localBroadcastManager.registerReceiver(localReceiver, intentFilter);
// 再发送广播
Intent intent = new Intent("com.example.action.LOCAL_BROADCAST");
localBroadcastManager.sendBroadcast(intent);
// 省略了部分代码
@Override
protected void onDestroy() {
  // 取消注册也要是要localBroadcastManager的方法
  localBroadcastManager.unregisterReceiver(localReceiver);
  super.onDestroy();
}</code></pre>
</div>
<p>LocalReceiver</p>
<div>
<pre class="prettyprint linenums"><code>package com.example.administrator.broadcasttest;

import android.content.BroadcastReceiver;
import android.content.Context;
import android.content.Intent;
import android.widget.Toast;

public class LocalReceiver extends BroadcastReceiver {

    @Override
    public void onReceive(Context context, Intent intent) {
        Toast.makeText(context, "LocalReceiver", Toast.LENGTH_SHORT).show();
    }
}</code></pre>
</div>
<p>这样，这个广播接收器只能接受来自本应用的广播，而且其他程序也不会接收到这个广播了。</p>
<h2>自定义带权限的广播</h2>
<p>详见<a href="http://blog.csdn.net/javensun/article/details/7334230" rel="external nofollow noreferrer">WJ_S的CSDN</a></p>
<h3>谁可以接收我发出的广播？</h3>
<p>假设appA发出了带有权限的广播，那么appB中的广播接收器想要接收到，必须申请appA定义的权限。</p>
<p>appA中自定义权限</p>
<div>
<pre class="prettyprint linenums"><code>&lt;permission
    android:name="com.example.broadcasttest.RECEICVE_ABC"
    android:protectionLevel="normal"/&gt;</code></pre>
</div>
<p>其中protectionLevel有如下几种比较常见</p>
<pre class="prettyprint linenums"><code>normal：默认的，普通权限。应用安装前，用户可以看到相应的权限，但无需用户主动授权。
dangerous：危险权限，需要动态申请。Android会弹出对话框要求用户进行授权。常见的如：网络使用权限，发送短信权限、联系人信息使用权限等。
signature：只有和该apk(定义了这个权限的apk)用相同的签名的应用才可以申请该权限。</code></pre>
<p>appA发送带有权限的广播</p>
<div>
<pre class="prettyprint linenums"><code>Intent intent = new Intent("com.example.broadcasttest.MY_BROADCAST");
sendBroadcast(intent, "com.example.broadcasttest.RECEICVE_ABC");</code></pre>
</div>
<p>appB中的广播接收器若想接收这个广播，必须申请权限<code>&lt;uses-permission android:name="com.example.broadcasttest.RECEICVE_ABC"/&gt;</code>，没有申请权限的一概收不到。</p>
<h3>谁有权发送广播给我？</h3>
<p>比如appB想发送广播给appA，而appA带有权限。</p>
<div>
<pre class="prettyprint linenums"><code>Intent intent = new Intent("com.example.broadcasttest.MY_BROADCAST");
sendBroadcast(intent);</code></pre>
</div>
<p>appA中自定义的权限</p>
<div>
<pre class="prettyprint linenums"><code>&lt;permission
    android:name="com.example.broadcasttest.SEND_ABC"
    android:protectionLevel="normal"/&gt;</code></pre>
</div>
<p>且appA的接收器加上权限</p>
<div>
<pre class="prettyprint linenums"><code>&lt;receiver
    android:name=".MyBroadcastReceiver"
    android:enabled="true"
    android:exported="true"
    android:permission="com.example.broadcasttest.SEND_ABC" &gt;
  &lt;intent-filter&gt;
    &lt;action android:name="com.example.broadcasttest.MY_BROADCAST" /&gt;
  &lt;/intent-filter&gt;
&lt;/receiver&gt;</code></pre>
</div>
<p>这样appB发送的广播，想让appA也收到。则必须申请appA定义的权限。appB中</p>
<div>
<pre class="prettyprint linenums"><code>&lt;uses-permission android:name="com.example.broadcasttest.SEND_ABC" /&gt;</code></pre>
</div>
<p><strong>注意：onReceive方法不要进行耗时操作，当该方法运行时间过长还没结束，程序就会报错。</strong></p>
<hr>
<p>by @sunhaiyu</p>
<p>2017.5.11</p>												<div id="single_bottom"></div>
<script>insertAdIfNeeded();</script>
																
<h2>最新文章</h2>	
<ol>
						<li><a href="https://www.batexi.com/a/oqv172yq.html">在Mac上开启自带的Apache，httpd服务</a>
		</li>
						<li><a href="https://www.batexi.com/a/49ge0re8.html">web&period;xml文件加载顺序</a>
		</li>
						<li><a href="https://www.batexi.com/a/m8zkomv8.html">关于checkbox的全选和反选实例</a>
		</li>
						<li><a href="https://www.batexi.com/a/rql56o08.html">IOS setValue forKey</a>
		</li>
						<li><a href="https://www.batexi.com/a/m8znkr18.html">课时8&mdash;弹窗modal</a>
		</li>
						<li><a href="https://www.batexi.com/a/9rggol48.html">PHP图片等比缩放，并添加Logo水印特定代码和盯</a>
		</li>
						<li><a href="https://www.batexi.com/a/93ywwjn8.html">项目开发经常使用PHP功能</a>
		</li>
						<li><a href="https://www.batexi.com/a/90mrwo48.html">内容中断随想录（risc cpu的那些事）</a>
		</li>
						<li><a href="https://www.batexi.com/a/9rgnz5r8.html">使用CAShapeLayer绘图</a>
		</li>
						<li><a href="https://www.batexi.com/a/950jxge8.html">CREELINKS平台&lowbar;处理器CeAd资源使用说明&lpar;CeAd的配置与使用&rpar;</a>
		</li>
						<li><a href="https://www.batexi.com/a/qwjrpok8.html">Angular随笔第二课</a>
		</li>
						<li><a href="https://www.batexi.com/a/9jzvmyw8.html">HDMI转MIPI DSI芯片方案TC358870XBG</a>
		</li>
						<li><a href="https://www.batexi.com/a/93y62nn8.html">beanstalk 安装</a>
		</li>
						<li><a href="https://www.batexi.com/a/qxkmj1z8.html">Spring Cache 笔记</a>
		</li>
						<li><a href="https://www.batexi.com/a/95062om8.html">1、在Centos上安装Grafana</a>
		</li>
						<li><a href="https://www.batexi.com/a/9j10dw09.html">JavaScript作用域&lpar;第七天&rpar;</a>
		</li>
						<li><a href="https://www.batexi.com/a/93wwkj0q.html">alert换行</a>
		</li>
						<li><a href="https://www.batexi.com/a/8zyrevv9.html">springBoot整合多数据源</a>
		</li>
						<li><a href="https://www.batexi.com/a/9gjzrp49.html">ES6  用Promise对象实现的 Ajax 操作</a>
		</li>
						<li><a href="https://www.batexi.com/a/qnvp6kg8.html">Ubuntu 16&period;04 fatal&colon; Unable to find remote helper for &amp;&num;39&semi;https&amp;&num;39&semi;</a>
		</li>
		</ol>
	

<h2>热门文章</h2>	
<ol>
									<li><a href="https://www.batexi.com/a/8kpvwgj9.html">Kubernetes部分Volume类型介绍及yaml示例</a>
			</li>
						<li><a href="https://www.batexi.com/a/9jz2yme8.html">源码安装zabbix&lowbar;server服务端</a>
			</li>
						<li><a href="https://www.batexi.com/a/qy1gwjdq.html">php后台模板html拼接写法</a>
			</li>
						<li><a href="https://www.batexi.com/a/8ojy1jpq.html">SAP PI入门</a>
			</li>
						<li><a href="https://www.batexi.com/a/q4zdj739.html">手机app微信支付后台处理流程</a>
			</li>
						<li><a href="https://www.batexi.com/a/9gegj248.html">Linux 内核综述</a>
			</li>
						<li><a href="https://www.batexi.com/a/8ojy4r1q.html">配置tomcat的远程调试</a>
			</li>
						<li><a href="https://www.batexi.com/a/q4zd4ge9.html">vijos1011题解</a>
			</li>
						<li><a href="https://www.batexi.com/a/950dpd68.html">vue&period;js 生命周期</a>
			</li>
						<li><a href="https://www.batexi.com/a/q1k45o49.html">Chrome浏览器扩展开发系列之十四：本地消息机制Native messaging</a>
			</li>
			</ol>			
							
					</div>

					
<div class="next-prev-posts clearfix">
</div>
						 
				</div>
				
	<div class="clear"></div>

			</div>	
			

		</div>
</div>
</div>


<div class="clearfix"></div>
<div id="footer" class="two-s-footer">
	<div class="footer-box">
		<div class="container">
			<div class="row" style="padding-left: 15px;padding-right: 15px;">
			<div class="nav-footer">
				<a href="/">Home</a>
				</div>
				<div class="copyright-footer">
					<p>Powered By WordPress</p>
				</div>
							</div>
		</div>
	</div>
</div>
<div style="display:none">

</div>
<script src="//n4.ikafan.com/assets/js/echo.js"></script>
<script>
    echo.init({
      offset: 100,
      throttle: 250,
      unload: false,
      callback: function (element, op) {
        console.log(element, 'has been', op + 'ed')
      }
    });
 </script>
</body>
</html>
